---------------------------------------------
--1 CONSULTA: p_comptConsMes80
---------------------------------------------
CREATE OR REPLACE PROCEDURE p_comptConsMes80 (
    n_localitat IN VARCHAR2,
    n_data      IN NUMBER
 
)

is

-- variable local

   sum_mes             NUMBER;
   perc                NUMBER;
   mitja               NUMBER;
   n_localitat_test    VARCHAR2 (100);
   n_date		     DATE;
   noExisteixLocalitat EXCEPTION;
   invalid_date	     EXCEPTION;

  
   
begin

--Control d'excepcions
--Mirem que la localitat existeixi a la base de dades
  SELECT COUNT (*)
     INTO n_localitat_test
     FROM COMPTADOR
     WHERE lower(localitat) = lower(n_localitat);

   IF (n_localitat_test = 0)
   THEN
      RAISE noExisteixLocalitat;
   END IF;
   
   --Controlem que la data introduida sigui la correcte
   IF (length (to_char (n_data)) > 6) THEN
   RAISE invalid_date;
   END IF;
   
 

    --devuelve la media dada una fecha por contador
     select round (((0.8*AVG(SUM(l.CONSUM_MES)))),2) into mitja
     from   lectura_consum l, comptador c
     where  l.COD_COMPTADOR = c.COD_COMPTADOR and
	 TO_CHAR(l.DATA_LECTURA, 'MMYYYY') = n_data and l.ESTAT='actiu' and c.LOCALITAT = n_localitat
     group by TO_CHAR(l.DATA_LECTURA, 'MMYYYY'), l.COD_COMPTADOR;
     
         
begin

          declare cursor c_registros is
  
        
     select c.COD_COMPTADOR, t.COD_CONTRACTE, t.POTENCIA, SUM(l.CONSUM_MES) sum_mes
     from  comptador c, lectura_consum l, contracte t
     where c.COD_COMPTADOR = l.COD_COMPTADOR and 
           TO_CHAR(l.DATA_LECTURA, 'MMYYYY') = n_data and l.ESTAT='actiu' and t.COD_COMPTADOR = c.COD_COMPTADOR
	       and c.LOCALITAT =  n_localitat
     group by c.COD_COMPTADOR, t.COD_CONTRACTE, t.POTENCIA, TO_CHAR(l.DATA_LECTURA, 'MMYYYY') 
     order by c.COD_COMPTADOR, t.COD_CONTRACTE, t.POTENCIA, SUM(l.CONSUM_MES) asc;
     
     
     v_reg c_registros%rowtype;
     
     begin
     
       open c_registros;
    loop
    fetch c_registros into v_reg;
    exit when c_registros%NOTFOUND;
    
       if (v_reg.sum_mes > mitja)  then
          perc := (mitja/v_reg.sum_mes)*100;       
         dbms_output.put_line (' COD_CONTRACTE: '|| v_reg.COD_CONTRACTE || '      POTENCIA: '|| v_reg.POTENCIA || '      PERCENTATGE: '|| round ((perc),2) ||' %' );
       end if;      
       
    end loop;
           
      close c_registros;
    end;
 end;
 
 
 EXCEPTION
  
   WHEN noExisteixLocalitat
   THEN
      dbms_output.put_line ('ERROR: La localitat no est donada d''alta a la base de dades');
	  
	  
  WHEN invalid_date
   THEN
      dbms_output.put_line ('ERROR: El format de la data introduida no s correcte, ha de ser del tipus: ''MMYYYY''');  

    
END p_comptConsMes80;
/






---------------------------------------------
--2 CONSULTA: p_centMesEnergia
---------------------------------------------
CREATE OR REPLACE PROCEDURE p_centMesEnergia IS


cuenta number;


begin



  declare cursor c_registros is


     select sum (l.consum_mes) as consum, cc.COD_C_DISTRIBUCIO, cd.ADREA, cd.MAXIM_ENERGIA 
    from lectura_consum l, connecta_comptador cc, central_distribucio cd, comptador cm
    where l.COD_COMPTADOR = cc.COD_COMPTADOR and
          cc.COD_C_DISTRIBUCIO = cd.COD_C_DISTRIBUCIO and
                cm.ESTAT = 'actiu' and cd.ESTAT = 'actiu'and l.ESTAT = 'actiu' AND
       cc.ESTAT = 'actiu'
               
     group by cc.COD_C_DISTRIBUCIO, cd.ADREA, cd.MAXIM_ENERGIA
     order by consum desc; 
     
     


    v_reg c_registros%rowtype;
    
    begin
    
       open c_registros;
      cuenta := 0;
      fetch c_registros into v_reg;
    
      WHILE (cuenta < 10)  LOOP      
      cuenta := cuenta +1;  
               
       dbms_output.put_line (' ADREA: '|| v_reg.ADREA || '    ENERGIA EMESA: '|| v_reg.consum || '    MXIMA ENERGIA: '|| v_reg.MAXIM_ENERGIA );
     
	  
      fetch c_registros into v_reg;       
      END LOOP;   

           
      close c_registros;   
   end;   


END p_centMesEnergia;
/



---------------------------------------------
--3 CONSULTA: p_LinMesCarregada
---------------------------------------------

CREATE OR REPLACE PROCEDURE p_LinMesCarregada IS

idprod            INTEGER;
enemax            NUMBER;
suma              NUMBER;
cod_c_produccio   INTEGER;


BEGIN
  
   DECLARE CURSOR c_registros IS 

  --Retorna: codi de la linia, capacitat maxima que soporta la linia, energia que es consumeix d'aquesta linia i
  -- la carrega
  SELECT * FROM (
     SELECT DISTINCT A.COD_LINIA AS COD_LINIA, A.CAP_MAX AS CAPACITAT_MAX, A.ENERGIA_TRANS AS ENERGIA_TRANS, 
                     round (A.ENERGIA_TRANS/A.CAP_MAX,2) as CARGA  
     FROM (SELECT SUM (L.CONSUM_MES) AS ENERGIA_TRANS, AC.COD_LINIA AS COD_LINIA, LN.CAPACITAT_MAXIMA AS CAP_MAX
           FROM LECTURA_CONSUM L, CONNECTA_COMPTADOR CC, ALIMENTA_CENTRAL AC, LINIA LN
           WHERE L.COD_COMPTADOR = CC.COD_COMPTADOR AND
                 CC.COD_C_DISTRIBUCIO = AC.COD_C_DISTRIBUCIO AND
                 AC.COD_LINIA = LN.COD_LINIA AND L.ESTAT = 'actiu' AND
                 CC.ESTAT = 'actiu' AND AC.ESTAT = 'actiu' 
           GROUP BY AC.COD_LINIA, LN.CAPACITAT_MAXIMA) A, ALIMENTA_CENTRAL AC 
     WHERE AC.COD_LINIA = A.COD_LINIA
     ORDER BY CARGA DESC)
  WHERE ROWNUM <= 10;
  
  v_reg c_registros%rowtype;

BEGIN

 open c_registros;
    loop
    fetch c_registros into v_reg;
    exit when c_registros%NOTFOUND;
    
    --miro la central de producci que correspon a una linia
    select distinct ac.COD_C_PRODUCCIO into idprod
    from alimenta_central ac
    where v_reg.cod_linia = ac.COD_LINIA;
    
    
    -- miro la capacitat maxima de la central de produccio 
    select cp.ENERGIA_MAXIMA into enemax
    from central_produccio cp
    where idprod = cp.COD_C_PRODUCCIO;
    
    -- suma de les capacitats maximes de les linies que surten de una mateixa central de produccio
    select ac.COD_C_PRODUCCIO, sum (l.CAPACITAT_MAXIMA) into cod_c_produccio, suma
    from alimenta_central ac, linia l
    where ac.COD_LINIA = l.COD_LINIA and 
       ac.cod_c_produccio = idprod and l.ESTAT = 'actiu'
                group by ac.COD_C_PRODUCCIO;
    
    
    dbms_output.put_line (' COD_LINIA: '|| v_reg.COD_LINIA || '      CARGA: '|| v_reg.CARGA || '     AMPLIACI: '|| (enemax - suma) );
       
       
    end loop;
           
      close c_registros;
  
 end;  

END p_LinMesCarregada;
/




---------------------------------------------
--4 CONSULTA: p_comptAltaDisponibilitat
---------------------------------------------

CREATE OR REPLACE PROCEDURE p_comptAltaDisponibilitat IS

distribucions          NUMBER;
nifClient              VARCHAR2(10);
codi_contracte         INTEGER;
modelcompt             INTEGER;
codcomptador           INTEGER;
nif                    VARCHAR2(10);
cont                   INTEGER;
mod                    INTEGER;


BEGIN
  
   DECLARE CURSOR c_registros IS 
   
       --Mirem els comptadors que connecten a mes d'una central de distribucio

   SELECT COUNT (CC.COD_C_DISTRIBUCIO) AS distribucions, CC.COD_COMPTADOR AS codcomptador
   FROM CONNECTA_COMPTADOR CC, CONTRACTE CT
   WHERE CT.DATA_FI IS NULL AND
         cc.COD_COMPTADOR = ct.COD_COMPTADOR 
   GROUP BY CC.COD_COMPTADOR
   HAVING COUNT (CC.COD_C_DISTRIBUCIO) >1;


   v_reg c_registros%rowtype;
     
   BEGIN

     open c_registros;
     loop
     fetch c_registros into v_reg;
     exit when c_registros%NOTFOUND;
   
                 DECLARE CURSOR c_registros2 IS
        SELECT CL.NIF as nif, CT.COD_CONTRACTE as cont, CM.COD_MODEL as mod  
        FROM CONTRACTE CT, CLIENT CL, COMPTADOR CM
        WHERE CT.COD_CLIENT = CL.COD_CLIENT AND
              CT.COD_COMPTADOR = CM.COD_COMPTADOR AND
              CM.COD_COMPTADOR = v_reg.CODCOMPTADOR AND 
              CT.DATA_FI IS NULL AND CM.ESTAT = 'actiu';
                                      
               r_reg c_registros2%rowtype;
     
                  BEGIN

            open c_registros2;
          loop
          fetch c_registros2 into r_reg;
          exit when c_registros2%NOTFOUND; 
    
           dbms_output.put_line (' DNI: '|| r_reg.nif || '     CODI_CONTRACTE: '|| r_reg.cont || '     MODEL_COMPTADOR: '|| r_reg.mod);
       
           end loop;
    
                close c_registros2;
         end;  
             
        end loop;      
         close c_registros;
     end; 
  
END p_comptAltaDisponibilitat;
/



---------------------------------------------
--5 CONSULTA: p_consumProdCompt
---------------------------------------------
CREATE OR REPLACE PROCEDURE p_consumProdCompt (
    N_COD_C_PRODUCCIO  IN INTEGER,
    N_DATA_INICI       IN DATE,
    N_DATA_FI          IN DATE

)


IS 

N_COD_C_PRODUCCIO_TEST     INTEGER;
noExisteix_cod_c_produccio EXCEPTION;
campsBuits                 EXCEPTION;

BEGIN

  -- CONTROL D'EXCEPCIONS
  -- Verifiquem que el codi_c_produccio existeix a la taula CENTRAL_PRODUCCIO   
   SELECT COUNT (*)
     INTO N_COD_C_PRODUCCIO_TEST
     FROM CENTRAL_PRODUCCIO
   WHERE cod_c_produccio = N_COD_C_PRODUCCIO;

   IF (N_COD_C_PRODUCCIO_TEST = 0)
   THEN
      RAISE noExisteix_cod_c_produccio;
   END IF;
   
      --Verifiquem que els camps no siguin nuls

   IF (N_COD_C_PRODUCCIO IS NULL) OR (N_DATA_INICI IS NULL) OR (N_DATA_FI IS NULL) THEN 
     RAISE campsBuits;
   END IF; 
   
   
   
   
  
   DECLARE CURSOR c_registros IS 

     --Retorna la producci en el periode de dades pasades per parmetre
    SELECT SUM (EA.ENERGIA_PROD) AS PRODUCCIO
    FROM ENERGIA_ABSOLUTA EA
    WHERE EA.DATA_PROD BETWEEN N_DATA_INICI AND N_DATA_FI AND
       EA.COD_C_PRODUCCIO = N_COD_C_PRODUCCIO AND
      EA.VALID = 'si';
   
   v_reg c_registros%rowtype;
     
   BEGIN

     open c_registros;
     loop
     fetch c_registros into v_reg;
     exit when c_registros%NOTFOUND;
   
       DECLARE CURSOR c_registros2 IS
   
   -- Consum dels comptadors que depenen d'aquesta central de produccio en l'interval especicat
   
   SELECT SUM (A.CONSUM1) AS CONSUM
   FROM   
   (SELECT DISTINCT SUM (LC.CONSUM_MES) AS CONSUM1,  CC.COD_COMPTADOR
   FROM ALIMENTA_CENTRAL AC, CONNECTA_COMPTADOR CC, LECTURA_CONSUM LC
   WHERE AC.COD_C_DISTRIBUCIO = CC.COD_C_DISTRIBUCIO AND
     CC.COD_COMPTADOR = LC.COD_COMPTADOR
     AND AC.COD_C_PRODUCCIO = N_COD_C_PRODUCCIO AND
   LC.DATA_LECTURA BETWEEN N_DATA_INICI AND N_DATA_FI AND LC.ESTAT ='actiu'
   GROUP BY CC.COD_COMPTADOR, AC.COD_C_DISTRIBUCIO) A;
   
    r_reg c_registros2%rowtype;
     
  BEGIN
     open c_registros2;
     loop
        fetch c_registros2 into r_reg;
     exit when c_registros2%NOTFOUND; 
       
  dbms_output.put_line (' CENTRAL_PRODUCCIO: '|| N_COD_C_PRODUCCIO || '   DATA_INICI: '|| N_DATA_INICI || '   DATA_FI: '|| N_DATA_FI || '   CONSUM_COMPT: '|| r_reg.CONSUM || '   ENERGIA_PROD: ' || v_reg.PRODUCCIO);
  
  end loop;
  close c_registros2;
  end;  
             
  end loop;      
     close c_registros;
     end; 
   
   
     EXCEPTION
      WHEN noExisteix_cod_c_produccio
      THEN
          dbms_output.put_line ('ERROR: El codi de la central del producci no existeix');
      ROLLBACK;
   
      
      WHEN campsBuits
      THEN
          dbms_output.put_line ('ERROR: S''han d''omplir tots els parmetres d''entrada');
      ROLLBACK;
   

END p_consumProdCompt;
/



---------------------------------------------
--6 CONSULTA: p_percentModalitat
---------------------------------------------
CREATE OR REPLACE PROCEDURE p_percentModalitat (
    n_data_inici   DATE,
    n_data_fi      DATE
)

IS 

campsBuits                 EXCEPTION;

BEGIN

--Verifiquem que els camps no siguin nuls

   IF (n_data_inici IS NULL) OR (n_data_fi IS NULL) THEN 
     RAISE campsBuits;
   END IF; 
   

  
   DECLARE CURSOR c_registros IS 


     --Retorna el numero de lectures telematiques
  SELECT COUNT (LC.MODALITAT) AS TELEMATICA
  FROM LECTURA_CONSUM LC
  WHERE LC.DATA_LECTURA BETWEEN n_data_inici AND n_data_fi AND LC.ESTAT ='actiu' 
      AND LC.MODALITAT = 'telematica';
   
   v_reg c_registros%rowtype;
     
   BEGIN

     open c_registros;
     loop
     fetch c_registros into v_reg;
     exit when c_registros%NOTFOUND;
   
       DECLARE CURSOR c_registros2 IS
   
   -- Retorna el numero de lectures presencials
   
   SELECT COUNT (LC.MODALITAT) AS PRESENCIAL
   FROM LECTURA_CONSUM LC
   WHERE LC.DATA_LECTURA BETWEEN n_data_inici AND n_data_fi AND LC.ESTAT ='actiu' 
     AND LC.MODALITAT = 'presencial';
   
   r_reg c_registros2%rowtype;
     
  BEGIN
     open c_registros2;
     loop
        fetch c_registros2 into r_reg;
     exit when c_registros2%NOTFOUND; 
       
  dbms_output.put_line (' TELEMTICA %: '|| round ((((v_reg.telematica)/(r_reg.presencial+v_reg.telematica))*100),2) || '   PRESENCIAL %: '|| round((((r_reg.presencial)/( r_reg.presencial+v_reg.telematica))*100),2));
  
  end loop;
  close c_registros2;
  end;  
             
  end loop;      
     close c_registros;
     end; 
 
  EXCEPTION
	WHEN campsBuits
    THEN
    dbms_output.put_line ('ERROR: S''han d''omplir tots els parmetres d''entrada');   

END p_percentModalitat;
/






---------------------------------------------
--7 CONSULTA: p_antiguitatCompt
---------------------------------------------

CREATE OR REPLACE PROCEDURE p_antiguitatCompt (

  n_antiguitat number
)


IS

antiguitat   NUMBER;
contador     NUMBER;
noDades		 EXCEPTION;


BEGIN  
 
  contador := 0;
  DECLARE CURSOR c_registros IS

  --Es mostra el codi del comptador, l'any de la seva fabricaci i la seva antiguitat desde 
  --la seva fabricaci fins l'any actual

 
  SELECT * FROM 
  (SELECT C.COD_COMPTADOR, EXTRACT (YEAR FROM MC.DATA_FAB) ANY_FABRICACIO, ((to_char(sysdate, 'YYYY') -  EXTRACT (YEAR FROM MC.DATA_FAB))) AS antiguitat
  FROM COMPTADOR C, MODEL_COMPTADOR MC
  WHERE C.COD_MODEL = MC.COD_MODEL )
  WHERE antiguitat = n_antiguitat;
 
  v_reg c_registros%rowtype;    	
    
  BEGIN

  
  OPEN c_registros;
  LOOP
  FETCH c_registros INTO v_reg;
  exit when c_registros%NOTFOUND;   

  
   dbms_output.put_line (' CODI_COMPTADOR: '|| v_reg.COD_COMPTADOR || '     ' || ' ANY_FABRICACIO: '|| v_reg.ANY_FABRICACIO || '     ' || ' ANTIGUITAT: '|| v_reg.ANTIGUITAT);
        
   contador := contador +1;
   
   END LOOP;   

           
  CLOSE c_registros;  
   
  IF (contador = 0) THEN
  	 RAISE noDades;
  END IF;
  
 END;   

 EXCEPTION
 WHEN noDades THEN
 dbms_output.put_line ('AVS: No existeix cap comptador amb aquesta antiguitat');
 
 
 
END p_antiguitatCompt;
/









