CREATE OR REPLACE PROCEDURE p_baixaClient (
    n_cod_client        IN INTEGER,
    n_estat             IN VARCHAR2
)
IS

--Variables locals
   n_cod_client_test               VARCHAR2(100);
   rst                             VARCHAR2(100);
   err_msg                         VARCHAR2(100);
   noExisteix_cod_client           EXCEPTION;
   esNul_cod_client                EXCEPTION;
   no_actiu						   EXCEPTION;

   
BEGIN

  --Verifiquem que el cod_client no sigui nul
  IF ( n_cod_client  IS NULL) 
  THEN 
    RAISE esNul_cod_client;
  END IF; 
  
  --El codi del client ha d'existir
  SELECT COUNT (*)
     INTO n_cod_client_test  
     FROM CLIENT
     WHERE cod_client = n_cod_client;

   IF (n_cod_client_test = 0)
   THEN
      RAISE noExisteix_cod_client;
   END IF;
  
   --No es pot activar un client que estigu inactiu. Haur de tenir un altre codi_client
   IF (n_estat = 'actiu') THEN
   	  RAISE no_actiu;
   END IF; 
  
   --Fem la baixa lgica del resigre
   UPDATE CLIENT
   SET estat  = n_estat            
   WHERE cod_client = n_cod_client;
   
  
  -- Si el registre d'un client ha quedat inactiu, el contracte associat tamb ho haur d'estar
  
  IF (n_estat = 'inactiu') then
  
    UPDATE CONTRACTE
  SET estat = n_estat
  WHERE cod_client = n_cod_client;
  END IF;
  
   
   
   -- Fi de les operacions
   rst := 'OK: El client s inactiu';

   p_insertLog('p_baixaClient', 'n_cod_client: ' || n_cod_client || ', ' ||
               'n_estat: ' || n_estat, rst);
   COMMIT; 
   
   
   
EXCEPTION
   WHEN noExisteix_cod_client
   THEN
      rst := 'ERROR: El codi_client no existeix';
      
   p_insertLog('p_baixaClient', 'n_cod_client: ' || n_cod_client || ', ' ||
               'n_estat: ' || n_estat, rst);
      ROLLBACK;
   
   WHEN esNul_cod_client
   THEN
      rst := 'ERROR: El cod_client no pot ser nul';
      
   p_insertLog('p_baixaClient', 'n_cod_client: ' || n_cod_client || ', ' ||
               'n_estat: ' || n_estat, rst);
      ROLLBACK;
   
   WHEN no_actiu
   THEN
      rst := 'ERROR: No es pot activar un client inactiu';
      
   p_insertLog('p_baixaClient', 'n_cod_client: ' || n_cod_client || ', ' ||
               'n_estat: ' || n_estat, rst);
      ROLLBACK;
   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
   p_insertLog('p_baixaClient', 'n_cod_client: ' || n_cod_client || ', ' ||
               'n_estat: ' || n_estat, rst);
      ROLLBACK;



END p_baixaClient;
/

