CREATE OR REPLACE PROCEDURE p_baixaComptador (
    n_cod_comptador IN INTEGER,
 n_estat         IN VARCHAR2
  
)
IS  

--Variables locals
   n_cod_comptador_test        INTEGER;
   err_msg                     VARCHAR2(100);
   rst                         VARCHAR2(100);
   errorEscriptura             EXCEPTION;
   noExisteix_cod_comptador    EXCEPTION;
   esNul_cod_comptador         EXCEPTION;
   no_actiu					   EXCEPTION;
   
BEGIN

  --El cod_comptador no pot ser nul
  IF ( n_cod_comptador  IS NULL) 
  THEN 
    RAISE esNul_cod_comptador;
  END IF; 
  
  --El codi del comptador ha d'existir
  SELECT COUNT (*)
     INTO n_cod_comptador_test
     FROM COMPTADOR
     WHERE cod_comptador = n_cod_comptador;

   IF (n_cod_comptador_test = 0)
   THEN
      RAISE noExisteix_cod_comptador;
   END IF;
   
   --No es pot activar un comptador inactiu, s'haur de fer una
   --alta nova amb un nou codi comptador
   
   IF (n_estat = 'actiu') THEN
   RAISE no_actiu;
   END IF;
   
   -- Verifiquem que el camp 'estat' est escrit correctament: actiu o inactiu
   IF LOWER (n_estat) NOT IN ('actiu', 'inactiu') THEN
      RAISE errorEscriptura;
   END IF;
  
   --Fem la baixa lgica: actualitzem el camp estat a inactiu
   UPDATE COMPTADOR 
   SET estat = n_estat
   WHERE cod_comptador = n_cod_comptador;
   
   --Si el registre del comptador s inactiu, el seu contracte
   --associat ha d'estar inactiu
   
     IF (n_estat = 'inactiu') then
  
    UPDATE CONTRACTE
  SET estat = n_estat
  WHERE cod_comptador = n_cod_comptador;
  END IF;
   
   --Si el registra del comptador s inacitu, totes les
   --lectures associades haurn d'estar inactives per aquest comptador
   
  IF (n_estat = 'inactiu') then  
    UPDATE LECTURA_CONSUM
  SET estat = n_estat
  WHERE cod_comptador = n_cod_comptador;
  END IF;
   
   -- Fi de les operacions
   
   rst := 'OK: El registre del comptador s inactiu';

    p_insertLog('p_baixaComptador', 'n_cod_comptador: ' || n_cod_comptador ||','||
                                 'n_estat: ' || n_estat, rst);
   COMMIT;
   
EXCEPTION
   WHEN noExisteix_cod_comptador
   THEN
      rst := 'ERROR: El codi del comptador no existeix';
      
    p_insertLog('p_baixaComptador', 'n_cod_comptador: ' || n_cod_comptador ||','||
                                 'n_estat: ' || n_estat, rst);
      ROLLBACK;
   
   WHEN no_actiu
   THEN
      rst := 'ERROR: No es pot activar un comptador inactiu';
      
    p_insertLog('p_baixaComptador', 'n_cod_comptador: ' || n_cod_comptador ||','||
                                 'n_estat: ' || n_estat, rst);
   ROLLBACK;
   
   
   WHEN esNul_cod_comptador
   THEN
      rst := 'ERROR: El codi del comptador s nul';
      
          p_insertLog('p_baixaComptador', 'n_cod_comptador: ' || n_cod_comptador ||','||
                                 'n_estat: ' || n_estat, rst);
      ROLLBACK;
   
      WHEN errorEscriptura
   THEN
      rst := 'ERROR: El camp ''estat'' no s''ha escrit correctament';
   
        p_insertLog('p_baixaComptador', 'n_cod_comptador: ' || n_cod_comptador ||','||
                                 'n_estat: ' || n_estat, rst);

   ROLLBACK;
   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
          p_insertLog('p_baixaComptador', 'n_cod_comptador: ' || n_cod_comptador ||','||
                                 'n_estat: ' || n_estat, rst);
      ROLLBACK;


END p_baixaComptador;
/

