CREATE OR REPLACE PROCEDURE         p_baixaContracte (
    n_cod_contracte IN INTEGER  
)
IS  

--Variables locals
   n_cod_contracte_test        INTEGER;
   err_msg                     VARCHAR2(100);
   rst                         VARCHAR2(100);
   noExisteix_cod_contracte    EXCEPTION;
   esNul_cod_contracte         EXCEPTION;
   
BEGIN

  --El cod_contracte pot ser nul
  IF ( n_cod_contracte  IS NULL) 
  THEN 
    RAISE esNul_cod_contracte;
  END IF; 
  
  --El codi del comptador ha d'existir
  SELECT COUNT (*)
     INTO n_cod_contracte_test
     FROM CONTRACTE
     WHERE cod_contracte = n_cod_contracte;

   IF (n_cod_contracte_test = 0)
   THEN
      RAISE noExisteix_cod_contracte;
   END IF;
  
   --Esborrem el contracte noms si l'estat de registre est inactiu
   DELETE FROM CONTRACTE 
   WHERE cod_contracte = n_cod_contracte and
         estat = 'inactiu';
   
   -- Fi de les operacions
   rst := 'OK: S''ha donat de baixa el contracte';

    p_insertLog('p_baixaContracte', 'n_cod_contracte: ' || n_cod_contracte, rst);
   COMMIT;
   
EXCEPTION
   WHEN noExisteix_cod_contracte
   THEN
      rst := 'ERROR: El codi del contracte no existeix';
      
      p_insertLog('p_baixaContracte', 'n_cod_contracte: ' || n_cod_contracte, rst);
      ROLLBACK;
   
   WHEN esNul_cod_contracte
   THEN
      rst := 'ERROR: El codi del contracte no pot ser nul';
      
      p_insertLog('p_baixaContracte', 'n_cod_contracte: ' || n_cod_contracte, rst);
      ROLLBACK;
   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
      p_insertLog('p_baixaContracte', 'n_cod_contracte: ' || n_cod_contracte, rst);
      ROLLBACK;


END p_baixaContracte;
/

