CREATE OR REPLACE PROCEDURE p_baixaLecturaConsum (
    n_cod_lect_consum   IN INTEGER,
    n_estat             IN VARCHAR2
)
IS

--Variables locals
   n_cod_lect_consum_test          INTEGER;
   err_msg                         VARCHAR2(100);
   rst                   VARCHAR2(100);
   n_cod_comptador       INTEGER;
   a_cod_c_produccio      INTEGER;
   EXISTE_CODPRO       INTEGER;
   consum_mes        NUMBER;
   n_data_lectura       DATE;
   n_anyo         NUMBER;
   noExisteix_cod_lect_consum      EXCEPTION;
   esNul_cod_lect_consum           EXCEPTION;
   
BEGIN

  --Verifiquem que el cod_lect_consum no sigui nul
  IF ( n_cod_lect_consum  IS NULL) 
  THEN 
    RAISE esNul_cod_lect_consum;
  END IF; 
  
  --El codi de la LECTURA_CONSUM ha d'existir
  SELECT COUNT (*)
     INTO n_cod_lect_consum_test
     FROM LECTURA_CONSUM
     WHERE cod_lect_consum = n_cod_lect_consum;

   IF (n_cod_lect_consum_test = 0)
   THEN
      RAISE noExisteix_cod_lect_consum;
   END IF;
  
   --Fem la baixa lgica del resigre
   UPDATE LECTURA_CONSUM
   SET estat  = n_estat            
   WHERE cod_lect_consum = n_cod_lect_consum;
   
   
   
  --ESTADISTICA: EST_CONSUM_COMTPADOR---------------------------------------------------------------------------
  
  --Obtenim el codi del comptador a partir del codi de la lectura  
  SELECT COD_COMPTADOR INTO n_cod_comptador
  FROM LECTURA_CONSUM 
  WHERE COD_LECT_CONSUM = n_cod_lect_consum;
  
  --Obtenim el consum del comptador a partir a partir del codi de la lectura 
  
  SELECT CONSUM_MES INTO consum_mes
  FROM LECTURA_CONSUM 
  WHERE COD_LECT_CONSUM = n_cod_lect_consum;
  
  
  --Obtenim el cod_c_produccio corresponent al cod_comptador
   a_cod_c_produccio := getCodProduccio (n_cod_comptador);
   
   IF (n_estat = 'inactiu') THEN
      --Actualitzem la taula EST_CONSUM_COMPTADOR
     --Verifiquem que existeix el cod_c_produccio
     SELECT COUNT (*)
      INTO EXISTE_CODPRO
      FROM EST_CONSUM_COMPTADOR EC
      WHERE EC.COD_C_PRODUCCIO = a_cod_c_produccio;
  
       p_modEstConsumComptador (a_cod_c_produccio, (consum_mes *(-1)));
  
  END IF;
  
 --------------------------------------------------------------------------------------
 --ESTADISTICA: EST_VALOR_MITJA-------------------------------------------------------
 --En el moment que es fa una baixa lgica de la taula LECTURA_CONSUM s'actualitza
 --tota la taula EST_VALOR_MITJA
 
    p_altaEstValorMitja();  
 --------------------------------------------------------------------------------------
   
   
   --------------------------------------------------------------------------------------
 --ESTADISTICA: EST_lINIA CARREGADA------------------------------------------------------
 --En el moment que es fa una baixa lgica de la taula LECTURA_CONSUM s'actualitza
 --tota la taula EST_LINIA_CARREGADA
 
    p_estLiniaCarregada(); 
 -------------------------------------------------------------------------------------- 
   
 
  --------------------------------------------------------------------------------------
   --EST_PERCENTATGE_LINIES
   
   --Hem de saber la data_lectura de la linia que es donar de baixa per tal de poder
   --cridar al procediment p_modPercentatgeLinies(n_anyo);
   
   SELECT LC.DATA_LECTURA INTO n_data_lectura
   FROM LECTURA_CONSUM LC
   WHERE LC.COD_LECT_CONSUM = n_cod_lect_consum;
   
  
    --Obtenim el l'any de la data_lectura de la taula lectura_consum per EST_PERCENTATGE_LINIES
    SELECT EXTRACT (YEAR FROM LC.DATA_LECTURA) INTO n_anyo
    FROM LECTURA_CONSUM LC
    WHERE LC.DATA_LECTURA = n_data_lectura
    GROUP BY LC.DATA_LECTURA;
 
   --Cridem al procediment qu far tots els calculs de l'estadistica EST_PERCENTATGE_LINIES
 
       p_modEstPercentatgeLinies (n_anyo);  
  
  -------------------------------------------------------------------------------------- 
   
   
   
   -- Fi de les operacions
   rst := 'OK: S''ha actualitzat el camp ''estat'' correctament';

   p_insertLog('p_baixaLecturaConsum', 'n_cod_lect_consum: ' || n_cod_lect_consum || ', ' ||
               'n_estat: ' || n_estat, rst);
   COMMIT; 
   
   
   
EXCEPTION
   WHEN noExisteix_cod_lect_consum
   THEN
      rst := 'ERROR: El codi lectura_consum no existeix';
      
  p_insertLog('p_baixaLecturaConsum', 'n_cod_lect_consum: ' || n_cod_lect_consum || ', ' ||
               'n_estat: ' || n_estat, rst);
      ROLLBACK;
   
   WHEN esNul_cod_lect_consum
   THEN
      rst := 'ERROR: El codi de lectura_consum no pot ser nul';
      
  p_insertLog('p_baixaLecturaConsum', 'n_cod_lect_consum: ' || n_cod_lect_consum || ', ' ||
               'n_estat: ' || n_estat, rst);
      ROLLBACK;
   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
  p_insertLog('p_baixaLecturaConsum', 'n_cod_lect_consum: ' || n_cod_lect_consum || ', ' ||
               'n_estat: ' || n_estat, rst);
      ROLLBACK;

END p_baixaLecturaConsum;
/

