CREATE OR REPLACE PROCEDURE p_baixaLinia ( 
   n_cod_linia IN INTEGER ,
   n_estat    IN VARCHAR2 
)
IS  

--Variables locals
   n_cod_linia_test        INTEGER;
   err_msg                 VARCHAR2(100);
   rst                     VARCHAR2(100);
   noExisteix_cod_linia    EXCEPTION;
   esNul_cod_linia         EXCEPTION;
   errorEscriptura         EXCEPTION;
   no_actiu				   EXCEPTION;
   
BEGIN

  --El cod_linia pot ser nul
  IF ( n_cod_linia  IS NULL) 
  THEN 
    RAISE esNul_cod_linia;
  END IF; 
  
  --El codi de la linia ha d'existir
  SELECT COUNT (*)
     INTO n_cod_linia_test
     FROM LINIA
     WHERE cod_linia = n_cod_linia;

   IF (n_cod_linia_test = 0)
   THEN
      RAISE noExisteix_cod_linia;
   END IF;
   
   --No es pot activar una linia inactiva, en aquest cas
   --s'haur de fer una alta nova
   IF (n_estat = 'actiu') THEN
   RAISE no_actiu;
   END IF;
   
   
   -- Verifiquem que el camp 'estat' est escrit correctament: actiu o inactiu
   IF LOWER (n_estat) NOT IN ('actiu', 'inactiu') THEN
      RAISE errorEscriptura;
   END IF;
  
   --Fem la baixa logica de linia actualitzatn el camp estat d'actiu a inactiu
   UPDATE LINIA
   SET estat = n_estat
   WHERE cod_linia = n_cod_linia;
   
   -- Fi de les operacions
   rst := 'OK: La linia s inactiva';

    p_insertLog('p_baixaLinia', 'n_cod_linia: ' || n_cod_linia, rst);
   COMMIT;
   
EXCEPTION
   WHEN noExisteix_cod_linia
   THEN
      rst := 'ERROR: El codi de la linia no existeix';
      
      p_insertLog('p_baixaLinia', 'n_cod_linia: ' || n_cod_linia, rst);
      ROLLBACK;
	  
	  
   WHEN no_actiu
   THEN
      rst := 'ERROR: No es pot activa una linia inactiva';
      
      p_insertLog('p_baixaLinia', 'n_cod_linia: ' || n_cod_linia, rst);
      ROLLBACK;	  
   
   WHEN esNul_cod_linia
   THEN
      rst := 'ERROR: El codi de la linia no pot ser nul';
      
      p_insertLog('p_baixaLinia', 'n_cod_linia: ' || n_cod_linia, rst);
      ROLLBACK;
   
   WHEN errorEscriptura
   THEN
      rst := 'ERROR: El camp ''estat'' no s''ha escrit correctament';
      
      p_insertLog('p_baixaLinia', 'n_cod_linia: ' || n_cod_linia, rst);
      ROLLBACK;
   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
      p_insertLog('p_baixaLinia', 'n_cod_linia: ' || n_cod_linia, rst);
      ROLLBACK;

END p_baixaLinia;
/

