CREATE OR REPLACE PROCEDURE         p_baixaModComptador (
   n_cod_model          IN    INTEGER
  
)
IS  

--Variables locasl
   n_cod_model_test         INTEGER;
   err_msg                  VARCHAR2(100);
   rst                      VARCHAR2(100);
   noExisteix_cod_model     EXCEPTION;
   esNul_cod_model          EXCEPTION;
   
BEGIN

  --El cod_model no pot ser nul
  IF ( n_cod_model  IS NULL) 
  THEN 
    RAISE esNul_cod_model;
  END IF; 
  
  --El codi del model ha d'existir
  SELECT COUNT (*)
     INTO n_cod_model_test
     FROM MODEL_COMPTADOR
     WHERE cod_model = n_cod_model;

   IF (n_cod_model_test = 0)
   THEN
      RAISE noExisteix_cod_model;
   END IF;
  
   --Esborrem el model
   DELETE FROM MODEL_COMPTADOR 
   WHERE cod_model = n_cod_model;
   
   -- Fi de les operacions
   rst := 'OK';

    p_insertLog('p_baixaModComptador', 'n_cod_model: ' || n_cod_model, rst);
   COMMIT;
   
EXCEPTION
   WHEN noExisteix_cod_model
   THEN
      rst := 'ERROR: El codi del model no existeix';
      
      p_insertLog('p_baixaModComptador', 'n_cod_model: ' || n_cod_model, rst);
      ROLLBACK;
   
   WHEN esNul_cod_model
   THEN
      rst := 'ERROR: El codi del model s nul';
      
      p_insertLog('p_baixaModComptador', 'n_cod_model: ' || n_cod_model, rst);
      ROLLBACK;
   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
      p_insertLog('p_baixaModComptador', 'n_cod_model: ' || n_cod_model, rst);
      ROLLBACK;


END p_baixaModComptador;
/

