CREATE OR REPLACE PROCEDURE         p_baixaSolar (
    n_cod_c_produccio  IN INTEGER  
)
IS  

--Variables locals
   n_cod_c_produccio_test          INTEGER;
   err_msg                         VARCHAR2(100);
   rst                             VARCHAR2(100);
   noExisteix_cod_c_produccio      EXCEPTION;
   esNul_cod_c_produccio           EXCEPTION;
   
BEGIN

  --Verifiquem que el ccod_c_produccio no sigui nul
  IF ( n_cod_c_produccio  IS NULL) 
  THEN 
    RAISE esNul_cod_c_produccio;
  END IF; 
  
  --El codi de la central de producci ha d'existir
  SELECT COUNT (*)
     INTO n_cod_c_produccio_test
     FROM CENTRAL_PRODUCCIO
     WHERE cod_c_produccio = n_cod_c_produccio;

   IF (n_cod_c_produccio_test = 0)
   THEN
      RAISE noExisteix_cod_c_produccio;
   END IF;
  
   --Esborrem la central termica
   DELETE FROM SOLAR 
   WHERE cod_c_produccio = n_cod_c_produccio;
   
   -- Fi de les operacions
   rst := 'OK: S''ha donat de baixa la central solar';

   p_insertLog('p_baixaSolar', 'n_cod_c_produccio: ' || n_cod_c_produccio, rst);
   COMMIT;
   
EXCEPTION
   WHEN noExisteix_cod_c_produccio
   THEN
      rst := 'ERROR: El codi de la central de producci no existeix';
      
     p_insertLog('p_baixaSolar', 'n_cod_c_produccio: ' || n_cod_c_produccio, rst);
      ROLLBACK;
   
   WHEN esNul_cod_c_produccio
   THEN
      rst := 'ERROR: El codi de la central de producci no pot ser nul';
      
        p_insertLog('p_baixaSolar', 'n_cod_c_produccio: ' || n_cod_c_produccio, rst);
      ROLLBACK;
   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
         p_insertLog('p_baixaSolar', 'n_cod_c_produccio: ' || n_cod_c_produccio, rst);
      ROLLBACK;


END p_baixaSolar;
/

