CREATE OR REPLACE PROCEDURE         p_modCarbo (
  n_cod_c_produccio    IN INTEGER,
   n_emissio_co2       IN NUMBER
 

)
IS

-- Variables locals
        rst                             VARCHAR2(2000);
        cod_c_produccio_test            INTEGER;
        err_msg                         VARCHAR2(100);
        existeixenCampsNuls             EXCEPTION;
        noExisteix_cod_c_produccio      EXCEPTION;
    
     
BEGIN


  --verifiquem que els camps no nuls no siguin nuls
  IF (n_cod_c_produccio IS NULL) OR 
     (n_emissio_co2  IS NULL) 
  THEN 
    RAISE existeixenCampsNuls;
  END IF; 
  
  --verifiquem que el codi de la central de carb existeix
  SELECT COUNT (*)
  INTO cod_c_produccio_test
  FROM CARBO
  WHERE cod_c_produccio = n_cod_c_produccio;

  IF (cod_c_produccio_test = 0)
   THEN
  RAISE noExisteix_cod_c_produccio;
  END IF;

   
    -- Modifiquem la central de carb
   UPDATE CARBO
   SET emissio_co2  = n_emissio_co2           
   WHERE cod_c_produccio = n_cod_c_produccio;

   -- Fi de les operacions
   rst := 'OK: La central de carbo s''ha modificat correctament';

   p_insertLog('p_modCarbo',  
                'n_cod_c_produccio: ' || n_cod_c_produccio || ', ' ||
                'n_emissio_co2 : ' || n_emissio_co2, rst);
   COMMIT;

   EXCEPTION

   WHEN noExisteix_cod_c_produccio
   THEN
      rst := 'ERROR: El codi_c_produccio no existeix';
      
   p_insertLog('p_modCarbo',  
                'n_cod_c_produccio: ' || n_cod_c_produccio || ', ' ||
                'n_emissio_co2 : ' || n_emissio_co2, rst);
      ROLLBACK;

  
 
   WHEN existeixenCampsNuls
   THEN
      rst := 'ERROR: Existeixen camps buits que no poden ser nuls';
      
   p_insertLog('p_modCarbo',  
                'n_cod_c_produccio: ' || n_cod_c_produccio || ', ' ||
                'n_emissio_co2 : ' || n_emissio_co2, rst);
      ROLLBACK;

    
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
   p_insertLog('p_modCarbo',  
                'n_cod_c_produccio: ' || n_cod_c_produccio || ', ' ||
                'n_emissio_co2 : ' || n_emissio_co2, rst);
      ROLLBACK;


END p_modCarbo;
/

