CREATE OR REPLACE PROCEDURE         p_modLinia (

    n_cod_linia        IN INTEGER,
    n_capacitat_maxima IN NUMBER 


)
IS

-- Variables locals
    rst                            VARCHAR2(2000);
    cod_linia_test                 INTEGER;
    err_msg                        VARCHAR2(100);
    existeixenCampsNuls            EXCEPTION;
    noExisteix_cod_linia           EXCEPTION;

   
BEGIN


  --verifiquem que els camps no nuls no siguin nuls
  IF (n_cod_linia IS NULL) OR 
     (n_capacitat_maxima IS NULL)  
  THEN 
    RAISE existeixenCampsNuls;
  END IF; 
  
  --verifiquem que la linia a modificar existeix
  SELECT COUNT (*)
  INTO cod_linia_test
  FROM LINIA
  WHERE cod_linia = n_cod_linia;

  IF (cod_linia_test = 0)
   THEN
  RAISE noExisteix_cod_linia;
  END IF;
 
  
    -- Modifiquem la linia
   UPDATE LINIA
   SET capacitat_maxima = n_capacitat_maxima         
   WHERE cod_linia = n_cod_linia;

   -- Fi de les operacions
   rst := 'OK: La linia s''ha modificat correctament';

   p_insertLog('p_modLinia',  
                'n_cod_linia: ' || n_cod_linia || ', ' ||
                'n_capacitat_maxima: ' || n_capacitat_maxima, rst);
   COMMIT;

   EXCEPTION

   WHEN noExisteix_cod_linia
   THEN
      rst := 'ERROR: El codi de la linia no existeix';
      
   p_insertLog('p_modLinia',  
                'n_cod_linia: ' || n_cod_linia || ', ' ||
                'n_capacitat_maxima: ' || n_capacitat_maxima, rst);
      ROLLBACK;

  
 
   WHEN existeixenCampsNuls
   THEN
      rst := 'ERROR: Existeixen camps buits que no poden ser nuls';
      
   p_insertLog('p_modLinia',  
                'n_cod_linia: ' || n_cod_linia || ', ' ||
                'n_capacitat_maxima: ' || n_capacitat_maxima, rst);
      ROLLBACK;
   
    
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
   p_insertLog('p_modLinia',  
                'n_cod_linia: ' || n_cod_linia || ', ' ||
                'n_capacitat_maxima: ' || n_capacitat_maxima, rst);
      ROLLBACK;



END p_modLinia;
/

