CREATE OR REPLACE PROCEDURE         p_modSolar (
   n_cod_c_produccio    IN INTEGER,
   n_num_panells        IN NUMBER

)
IS

-- Variables locals
        rst                             VARCHAR2(2000);
        cod_c_produccio_test            INTEGER;
        err_msg                         VARCHAR2(100);
        existeixenCampsNuls             EXCEPTION;
        noExisteix_cod_c_produccio      EXCEPTION;
    
     
BEGIN


  --verifiquem que els camps no nuls no siguin nuls
  IF (n_cod_c_produccio IS NULL) OR 
     (n_num_panells  IS NULL) 
  THEN 
    RAISE existeixenCampsNuls;
  END IF; 
  
  --verifiquem que el codi de la central de carb existeix
  SELECT COUNT (*)
  INTO cod_c_produccio_test
  FROM SOLAR
  WHERE cod_c_produccio = n_cod_c_produccio;

  IF (cod_c_produccio_test = 0)
   THEN
  RAISE noExisteix_cod_c_produccio;
  END IF;

   
    -- Modifiquem la central solars
   UPDATE SOLAR
   SET num_panells  = n_num_panells            
   WHERE cod_c_produccio = n_cod_c_produccio;

   -- Fi de les operacions
   rst := 'OK: La central solar s''ha modificat correctament';

   p_insertLog('p_modSolar',  
                'n_cod_c_produccio: ' || n_cod_c_produccio || ', ' ||
                'n_num_panells : ' || n_num_panells, rst);
   COMMIT;

   EXCEPTION

   WHEN noExisteix_cod_c_produccio
   THEN
      rst := 'ERROR: El codi_c_produccio no existeix';
      
   p_insertLog('p_modSolar',  
                'n_cod_c_produccio: ' || n_cod_c_produccio || ', ' ||
                'n_num_panells : ' || n_num_panells, rst);
      ROLLBACK;

  
 
   WHEN existeixenCampsNuls
   THEN
      rst := 'ERROR: Existeixen camps buits que no poden ser nuls';
      
   p_insertLog('p_modSolar',  
                'n_cod_c_produccio: ' || n_cod_c_produccio || ', ' ||
                'n_num_panells : ' || n_num_panells, rst);
      ROLLBACK;

    
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
   p_insertLog('p_modSolar',  
                'n_cod_c_produccio: ' || n_cod_c_produccio || ', ' ||
                'n_num_panells : ' || n_num_panells, rst);
      ROLLBACK;



END p_modSolar;
/

