CREATE OR REPLACE PROCEDURE p_LinMesCarregada IS

idprod            INTEGER;
enemax            NUMBER;
suma              NUMBER;
cod_c_produccio   INTEGER;


BEGIN
  
   DECLARE CURSOR c_registros IS 

  --Retorna: codi de la linia, capacitat maxima que soporta la linia, energia que es consumeix d'aquesta linia i
  -- la carrega
  SELECT * FROM (
     SELECT DISTINCT A.COD_LINIA AS COD_LINIA, A.CAP_MAX AS CAPACITAT_MAX, A.ENERGIA_TRANS AS ENERGIA_TRANS, 
                     round (A.ENERGIA_TRANS/A.CAP_MAX,2) as CARGA  
     FROM (SELECT SUM (L.CONSUM_MES) AS ENERGIA_TRANS, AC.COD_LINIA AS COD_LINIA, LN.CAPACITAT_MAXIMA AS CAP_MAX
           FROM LECTURA_CONSUM L, CONNECTA_COMPTADOR CC, ALIMENTA_CENTRAL AC, LINIA LN
           WHERE L.COD_COMPTADOR = CC.COD_COMPTADOR AND
                 CC.COD_C_DISTRIBUCIO = AC.COD_C_DISTRIBUCIO AND
                 AC.COD_LINIA = LN.COD_LINIA AND L.ESTAT = 'actiu' AND
                 CC.ESTAT = 'actiu' AND AC.ESTAT = 'actiu' 
           GROUP BY AC.COD_LINIA, LN.CAPACITAT_MAXIMA) A, ALIMENTA_CENTRAL AC 
     WHERE AC.COD_LINIA = A.COD_LINIA
     ORDER BY CARGA DESC)
  WHERE ROWNUM <= 10;
  
  v_reg c_registros%rowtype;

BEGIN

 open c_registros;
    loop
    fetch c_registros into v_reg;
    exit when c_registros%NOTFOUND;
    
    --miro la central de producci que correspon a una linia
    select distinct ac.COD_C_PRODUCCIO into idprod
    from alimenta_central ac
    where v_reg.cod_linia = ac.COD_LINIA;
    
    
    -- miro la capacitat maxima de la central de produccio 
    select cp.ENERGIA_MAXIMA into enemax
    from central_produccio cp
    where idprod = cp.COD_C_PRODUCCIO;
    
    -- suma de les capacitats maximes de les linies que surten de una mateixa central de produccio
    select ac.COD_C_PRODUCCIO, sum (l.CAPACITAT_MAXIMA) into cod_c_produccio, suma
    from alimenta_central ac, linia l
    where ac.COD_LINIA = l.COD_LINIA and 
       ac.cod_c_produccio = idprod and l.ESTAT = 'actiu'
                group by ac.COD_C_PRODUCCIO;
    
    
    dbms_output.put_line (' COD_LINIA: '|| v_reg.COD_LINIA || '      CARGA: '|| v_reg.CARGA || '     AMPLIACI: '|| (enemax - suma) );
       
       
    end loop;
           
      close c_registros;
  
 end;  

END p_LinMesCarregada;
/

