CREATE OR REPLACE PROCEDURE p_comptConsMes80 (
    n_localitat IN VARCHAR2,
    n_data      IN NUMBER
 
)

is

-- variable local

   sum_mes   NUMBER;
   perc      NUMBER;
   mitja     NUMBER;
   n_localitat_test VARCHAR2 (100);
   n_date		 DATE;
   noExisteixLocalitat EXCEPTION;
   invalid_date		   EXCEPTION;

  
   
begin

--Control d'excepcions
--Mirem que la localitat existeixi a la base de dades
  SELECT COUNT (*)
     INTO n_localitat_test
     FROM COMPTADOR
     WHERE lower(localitat) = lower(n_localitat);

   IF (n_localitat_test = 0)
   THEN
      RAISE noExisteixLocalitat;
   END IF;
   
   --Controlem que la data introduida sigui la correcte
   IF (length (to_char (n_data)) > 6) THEN
   RAISE invalid_date;
   END IF;
   
 

    --devuelve la media dada una fecha por contador
     select round (((0.8*AVG(SUM(l.CONSUM_MES)))),2) into mitja
     from   lectura_consum l, comptador c
     where  l.COD_COMPTADOR = c.COD_COMPTADOR and
	 TO_CHAR(l.DATA_LECTURA, 'MMYYYY') = n_data and l.ESTAT='actiu' and c.LOCALITAT = n_localitat
     group by TO_CHAR(l.DATA_LECTURA, 'MMYYYY'), l.COD_COMPTADOR;
     
         
begin

          declare cursor c_registros is
  
        
     select c.COD_COMPTADOR, t.COD_CONTRACTE, t.POTENCIA, SUM(l.CONSUM_MES) sum_mes
     from  comptador c, lectura_consum l, contracte t
     where c.COD_COMPTADOR = l.COD_COMPTADOR and 
           TO_CHAR(l.DATA_LECTURA, 'MMYYYY') = n_data and l.ESTAT='actiu' and t.COD_COMPTADOR = c.COD_COMPTADOR
	       and c.LOCALITAT =  n_localitat
     group by c.COD_COMPTADOR, t.COD_CONTRACTE, t.POTENCIA, TO_CHAR(l.DATA_LECTURA, 'MMYYYY') 
     order by c.COD_COMPTADOR, t.COD_CONTRACTE, t.POTENCIA, SUM(l.CONSUM_MES) asc;
     
     
     v_reg c_registros%rowtype;
     
     begin
     
       open c_registros;
    loop
    fetch c_registros into v_reg;
    exit when c_registros%NOTFOUND;
    
       if (v_reg.sum_mes > mitja)  then
          perc := (mitja/v_reg.sum_mes)*100;       
         dbms_output.put_line (' COD_CONTRACTE: '|| v_reg.COD_CONTRACTE || '      POTENCIA: '|| v_reg.POTENCIA || '      PERCENTATGE: '|| round ((perc),2) ||' %' );
       end if;      
       
    end loop;
           
      close c_registros;
    end;
 end;
 
 
 EXCEPTION
  
   WHEN noExisteixLocalitat
   THEN
      dbms_output.put_line ('ERROR: La localitat no est donada d''alta a la base de dades');
	  
	  
  WHEN invalid_date
   THEN
      dbms_output.put_line ('ERROR: El format de la data introduida no s correcte, ha de ser del tipus: ''MMYYYY''');  

    
END p_comptConsMes80;
/

