CREATE OR REPLACE PROCEDURE p_consumProdCompt (
    N_COD_C_PRODUCCIO  IN INTEGER,
    N_DATA_INICI       IN DATE,
    N_DATA_FI          IN DATE

)


IS 

N_COD_C_PRODUCCIO_TEST     INTEGER;
noExisteix_cod_c_produccio EXCEPTION;
campsBuits                 EXCEPTION;

BEGIN

  -- CONTROL D'EXCEPCIONS
  -- Verifiquem que el codi_c_produccio existeix a la taula CENTRAL_PRODUCCIO   
   SELECT COUNT (*)
     INTO N_COD_C_PRODUCCIO_TEST
     FROM CENTRAL_PRODUCCIO
   WHERE cod_c_produccio = N_COD_C_PRODUCCIO;

   IF (N_COD_C_PRODUCCIO_TEST = 0)
   THEN
      RAISE noExisteix_cod_c_produccio;
   END IF;
   
      --Verifiquem que els camps no siguin nuls

   IF (N_COD_C_PRODUCCIO IS NULL) OR (N_DATA_INICI IS NULL) OR (N_DATA_FI IS NULL) THEN 
     RAISE campsBuits;
   END IF; 
   
   
   
   
  
   DECLARE CURSOR c_registros IS 

     --Retorna la producci en el periode de dades pasades per parmetre
    SELECT SUM (EA.ENERGIA_PROD) AS PRODUCCIO
    FROM ENERGIA_ABSOLUTA EA
    WHERE EA.DATA_PROD BETWEEN N_DATA_INICI AND N_DATA_FI AND
       EA.COD_C_PRODUCCIO = N_COD_C_PRODUCCIO AND
      EA.VALID = 'si';
   
   v_reg c_registros%rowtype;
     
   BEGIN

     open c_registros;
     loop
     fetch c_registros into v_reg;
     exit when c_registros%NOTFOUND;
   
       DECLARE CURSOR c_registros2 IS
   
   -- Consum dels comptadors que depenen d'aquesta central de produccio en l'interval especicat
   
   SELECT SUM (A.CONSUM1) AS CONSUM
   FROM   
   (SELECT DISTINCT SUM (LC.CONSUM_MES) AS CONSUM1,  CC.COD_COMPTADOR
   FROM ALIMENTA_CENTRAL AC, CONNECTA_COMPTADOR CC, LECTURA_CONSUM LC
   WHERE AC.COD_C_DISTRIBUCIO = CC.COD_C_DISTRIBUCIO AND
     CC.COD_COMPTADOR = LC.COD_COMPTADOR
     AND AC.COD_C_PRODUCCIO = N_COD_C_PRODUCCIO AND
   LC.DATA_LECTURA BETWEEN N_DATA_INICI AND N_DATA_FI AND LC.ESTAT ='actiu'
   GROUP BY CC.COD_COMPTADOR, AC.COD_C_DISTRIBUCIO) A;
   
    r_reg c_registros2%rowtype;
     
  BEGIN
     open c_registros2;
     loop
        fetch c_registros2 into r_reg;
     exit when c_registros2%NOTFOUND; 
       
  dbms_output.put_line (' CENTRAL_PRODUCCIO: '|| N_COD_C_PRODUCCIO || '   DATA_INICI: '|| N_DATA_INICI || '   DATA_FI: '|| N_DATA_FI || '   CONSUM_COMPT: '|| r_reg.CONSUM || '   ENERGIA_PROD: ' || v_reg.PRODUCCIO);
  
  end loop;
  close c_registros2;
  end;  
             
  end loop;      
     close c_registros;
     end; 
   
   
     EXCEPTION
      WHEN noExisteix_cod_c_produccio
      THEN
          dbms_output.put_line ('ERROR: El codi de la central del producci no existeix');
      ROLLBACK;
   
      
      WHEN campsBuits
      THEN
          dbms_output.put_line ('ERROR: S''han d''omplir tots els parmetres d''entrada');
      ROLLBACK;
   

END p_consumProdCompt;
/

