CREATE OR REPLACE PROCEDURE p_percentModalitat (
    n_data_inici   DATE,
    n_data_fi      DATE
)

IS 

campsBuits                 EXCEPTION;

BEGIN

--Verifiquem que els camps no siguin nuls

   IF (n_data_inici IS NULL) OR (n_data_fi IS NULL) THEN 
     RAISE campsBuits;
   END IF; 
   

  
   DECLARE CURSOR c_registros IS 


     --Retorna el numero de lectures telematiques
  SELECT COUNT (LC.MODALITAT) AS TELEMATICA
  FROM LECTURA_CONSUM LC
  WHERE LC.DATA_LECTURA BETWEEN n_data_inici AND n_data_fi AND LC.ESTAT ='actiu' 
      AND LC.MODALITAT = 'telematica';
   
   v_reg c_registros%rowtype;
     
   BEGIN

     open c_registros;
     loop
     fetch c_registros into v_reg;
     exit when c_registros%NOTFOUND;
   
       DECLARE CURSOR c_registros2 IS
   
   -- Retorna el numero de lectures presencials
   
   SELECT COUNT (LC.MODALITAT) AS PRESENCIAL
   FROM LECTURA_CONSUM LC
   WHERE LC.DATA_LECTURA BETWEEN n_data_inici AND n_data_fi AND LC.ESTAT ='actiu' 
     AND LC.MODALITAT = 'presencial';
   
   r_reg c_registros2%rowtype;
     
  BEGIN
     open c_registros2;
     loop
        fetch c_registros2 into r_reg;
     exit when c_registros2%NOTFOUND; 
       
  dbms_output.put_line (' TELEMTICA %: '|| round ((((v_reg.telematica)/(r_reg.presencial+v_reg.telematica))*100),2) || '   PRESENCIAL %: '|| round((((r_reg.presencial)/( r_reg.presencial+v_reg.telematica))*100),2));
  
  end loop;
  close c_registros2;
  end;  
             
  end loop;      
     close c_registros;
     end; 
 
  EXCEPTION
	WHEN campsBuits
    THEN
    dbms_output.put_line ('ERROR: S''han d''omplir tots els parmetres d''entrada');   

END p_percentModalitat;
/

