CREATE OR REPLACE FUNCTION USR_ENE.getCodProduccio (n_cod_comptador INTEGER)

RETURN INTEGER
IS

  err_msg            VARCHAR2 (100);
  rst                VARCHAR2 (100);
  a_cod_c_produccio  INTEGER;
  
BEGIN

  --Obtenim el codi de la central de produccio a partir del
  --codi de comptador de la taula lectura_consum
  SELECT AC.COD_C_PRODUCCIO into a_cod_c_produccio
  FROM COMPTADOR C, CONNECTA_COMPTADOR CC, ALIMENTA_CENTRAL AC
  WHERE C.COD_COMPTADOR = n_cod_comptador AND
  		C.COD_COMPTADOR = CC.COD_COMPTADOR AND CC.ESTAT = 'actiu' AND
	    CC.COD_C_DISTRIBUCIO = AC.COD_C_DISTRIBUCIO AND AC.ESTAT = 'actiu';
	 

  --Retornem el codi de central de producci
  RETURN a_cod_c_produccio;
  
  
  EXCEPTION
  WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
   
      p_insertLog ('Func. getCodProduccio',  
             	   'cod_comptador:   ' || n_cod_comptador || ', ' ||
				   'cod_c_produccio:   ' || a_cod_c_produccio, rst);
      ROLLBACK;

END getCodProduccio;
/