CREATE OR REPLACE FUNCTION USR_ENE.getFilesByComptadorAndYear (n_cod_comptador INTEGER, n_year INTEGER)

RETURN INTEGER
IS

  err_msg VARCHAR2 (100);
  rst     VARCHAR2 (100);
  a_files NUMBER;
  
BEGIN

SELECT COUNT (*) INTO  a_files
FROM (
	 select EXTRACT (MONTH FROM LC.DATA_LECTURA) AS MES, LC.COD_COMPTADOR, EXTRACT (YEAR FROM LC.DATA_LECTURA) AS ANYO
	 from COMPTADOR C, CONNECTA_COMPTADOR CC, ALIMENTA_CENTRAL AC, LECTURA_CONSUM LC
	 WHERE LC.COD_COMPTADOR = n_cod_comptador AND EXTRACT (YEAR FROM LC.DATA_LECTURA) = n_year and
	 	   C.COD_COMPTADOR = CC.COD_COMPTADOR AND
	 	   CC.COD_C_DISTRIBUCIO = AC.COD_C_DISTRIBUCIO AND AC.ESTAT = 'actiu'
     GROUP BY LC.COD_COMPTADOR, EXTRACT (MONTH FROM LC.DATA_LECTURA), EXTRACT (YEAR FROM LC.DATA_LECTURA)) 
A;


RETURN a_files;

EXCEPTION
WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
   
      p_insertLog ('Func. getFiles ',  
             	   'cod_comptador:   ' || n_cod_comptador || ', ' ||
				   'files:   ' || a_files, rst);
      ROLLBACK;


END getFilesByComptadorAndYear;
/
