CREATE OR REPLACE PROCEDURE p_altaEstConsumComptador (
	   n_cod_c_produccio IN INTEGER,
	   n_consum			 IN NUMBER
	   


)
IS

campsBuits             EXCEPTION;
err_msg                VARCHAR2 (100);
rst              	   VARCHAR2(2000);


BEGIN

--Verifiquem que els camps no siguin nuls

     IF (n_cod_c_produccio IS NULL) OR (n_consum IS NULL)  THEN 
     RAISE campsBuits;
   END IF; 

   --Inserim el nou registre
   INSERT INTO EST_CONSUM_COMPTADOR (cod_c_produccio, consum) 
          VALUES (n_cod_c_produccio, n_consum);
   
   -- Fin de les operacions
   rst := 'OK: S''ha donat d''alta el consum';

   p_insertLog('p_altaEstConsumComptador', 
               'n_cod_c_produccio: ' || n_cod_c_produccio ||
               'n_consum: ' || n_consum, rst);
   COMMIT;
   
EXCEPTION

   WHEN campsBuits
   THEN
      rst := 'ERROR: Existeixen camps nuls que no haurien de ser nuls';
   p_insertLog('p_altaEstConsumComptador', 
               'n_cod_c_produccio: ' || n_cod_c_produccio ||
               'n_consum: ' || n_consum, rst);
      ROLLBACK;  
	  
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
   p_insertLog('p_altaEstConsumComptador', 
               'n_cod_c_produccio: ' || n_cod_c_produccio ||
               'n_consum: ' || n_consum, rst);
      ROLLBACK;

END p_altaEstConsumComptador;
/

