CREATE OR REPLACE PROCEDURE p_altaEstNomCentProduccio (
   n_anyo    IN number   


)
IS

campsBuits                 EXCEPTION;
err_msg                    VARCHAR2 (100);
rst                      VARCHAR2(2000);
n_percentatge_produccio    NUMBER;
cenprod_superen            NUMBER;
central                    NUMBER; 


BEGIN



--Mirem el numero de centrals que generen menys del 30% de la produccio
--tenint en compte la seva capacitat_maxima (aquesta dada ve donada en valors anuals)
SELECT COUNT (*) INTO  cenprod_superen  
FROM   
(SELECT SUM(EM.ENERGIA_PROD), EM.COD_C_PRODUCCIO, CP.CAPACITAT_MAXIMA
FROM ENERGIA_ABSOLUTA EM, CENTRAL_PRODUCCIO CP
WHERE EM.COD_C_PRODUCCIO = CP.COD_C_PRODUCCIO AND
      EXTRACT (YEAR FROM EM.DATA_PROD) = n_anyo AND
   EM.VALID = 'si'
GROUP BY EM.COD_C_PRODUCCIO, CP.CAPACITAT_MAXIMA
HAVING SUM(EM.ENERGIA_PROD) <= CP.CAPACITAT_MAXIMA * 0.3);


--Mirem el numero total de centrals que te la taula CENTRAL_PRODUCCIO      
   

SELECT COUNT (*) INTO central
FROM CENTRAL_PRODUCCIO;

 
   

--Inserim el nou registre
   INSERT INTO EST_NOMBRE_CENTRAL_PRODUCCIO (anyo, num_central_produccio) 
          VALUES (n_anyo, CENPROD_SUPEREN);
   
   -- Fin de les operacions
   rst := 'OK: S''ha donat d''alta el nombre de centrals';

   p_insertLog('p_estNomCentPro', 
               'anyo: ' || n_anyo ||
               'num_central_produccio: ' || cenprod_superen, rst);
   COMMIT;
   
EXCEPTION

   WHEN campsBuits
   THEN
      rst := 'ERROR: Existeixen camps nuls que no haurien de ser nuls';
   
  p_insertLog('p_estNomCentPro', 
               'anyo: ' || n_anyo ||
               'num_central_produccio: ' || cenprod_superen, rst);
      ROLLBACK;  
   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
  p_insertLog('p_estNomCentPro', 
               'anyo: ' || n_anyo ||
               'num_central_produccio: ' || cenprod_superen, rst);
      ROLLBACK;


END p_altaEstNomCentProduccio;
/

