CREATE OR REPLACE PROCEDURE p_altaEstPercentatgeLinies (
    n_anyo    IN number   


)
IS

campsBuits             EXCEPTION;
err_msg                VARCHAR2 (100);
rst                  VARCHAR2(2000);
n_percentatge_linies   NUMBER;
linies_superen     NUMBER;
linies       NUMBER;

BEGIN



   --Mirem el numero de linies que superen el 50% de l'energia consumida
--tenint en compte la seva capacitat_maxima (aquesta dada ve donada en valors anuals)
SELECT COUNT (*) INTO linies_superen 
FROM (  
      SELECT AC.COD_LINIA,  L.CAPACITAT_MAXIMA, SUM (LC.CONSUM_MES)
      FROM ALIMENTA_CENTRAL AC, LINIA L, CONNECTA_COMPTADOR CC, LECTURA_CONSUM LC
      WHERE AC.COD_LINIA = L.COD_LINIA AND
            AC.COD_C_DISTRIBUCIO = CC.COD_C_DISTRIBUCIO AND
            CC.COD_COMPTADOR = LC.COD_COMPTADOR AND LC.ESTAT = 'actiu' AND
            CC.ESTAT = 'actiu' AND AC.ESTAT = 'actiu' AND EXTRACT (YEAR FROM LC.DATA_LECTURA) = n_anyo
      GROUP BY AC.COD_LINIA, L.CAPACITAT_MAXIMA
      HAVING SUM (LC.CONSUM_MES) >= L.CAPACITAT_MAXIMA * 0.5);



--Mirem el numero total de linies que te la taula LINIES      
   
SELECT COUNT (*) INTO linies
FROM LINIA;



--Fem el caulcul del %

     n_percentatge_linies := round(((linies_superen/linies) * 100),2);
  


--Inserim el nou registre


   INSERT INTO EST_PERCENTATGE_LINIES (anyo, percentatge_linies) 
          VALUES (n_anyo, n_percentatge_linies);
   
   -- Fin de les operacions
   rst := 'OK: S''ha donat d''alta el percentatge';

   p_insertLog('p_altaEstPercentatgeLinies', 
               'anyo: ' || n_anyo ||
               'percentatge_linies: ' || n_percentatge_linies, rst);
   COMMIT;
   
EXCEPTION

   WHEN campsBuits
   THEN
      rst := 'ERROR: Existeixen camps nuls que no haurien de ser nuls';
   p_insertLog('p_altaEstPercentatgeLinies', 
               'anyo: ' || n_anyo ||
               'percentatge_linies: ' || n_percentatge_linies, rst);
      ROLLBACK;  
   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
   p_insertLog('p_altaEstPercentatgeLinies', 
               'anyo: ' || n_anyo ||
               'percentatge_linies: ' || n_percentatge_linies, rst);
      ROLLBACK;


END p_altaEstPercentatgeLinies;
/

