CREATE OR REPLACE PROCEDURE         p_altaEstValorMitja IS


err_msg                VARCHAR2 (100);
rst                  VARCHAR2(2000);
cod_linia      INTEGER;
anyo           NUMBER;
valor_mitja      NUMBER;

BEGIN


   --Inserim el nou registre a la taula EST_VALOR_MIJT amb totes les dades ja calculades
   --tenin en compte sempre que la linia introduida a LECTURA_COSUM sempre tigui el camp
   --valid = 'si'
   
   --Como mejora de proyecto se podra optimizar esta query para evitar hacer una recarga
   --de tabla en cada ocasin
   
   DELETE FROM est_valor_mitja;

   insert into est_valor_mitja (cod_linia, anyo, valor_mitja) 
   select a.a_cod_linia cod_linia, a.anyo anyo, sum(mitja) valor_mitja from (
   SELECT AC.COD_LINIA as a_cod_linia, l.COD_COMPTADOR,
    to_char(l.DATA_LECTURA, 'YYYY') anyo,
    round(sum (l.CONSUM_MES)/getFilesByComptadorAndYear(l.COD_COMPTADOR, to_char(l.DATA_LECTURA, 'YYYY')),2) mitja 
    FROM COMPTADOR C, CONNECTA_COMPTADOR CC, ALIMENTA_CENTRAL AC, lectura_consum l
    WHERE 
      C.COD_COMPTADOR = CC.COD_COMPTADOR AND
   CC.COD_C_DISTRIBUCIO = AC.COD_C_DISTRIBUCIO AND AC.ESTAT = 'actiu' and
   l.COD_COMPTADOR = cc.COD_COMPTADOR AND L.ESTAT = 'actiu'
   group by AC.COD_LINIA, l.COD_COMPTADOR, to_char(l.DATA_LECTURA, 'YYYY')
order by AC.COD_LINIA) a
group by a.a_cod_linia, a.anyo
order by a.a_cod_linia;
   
   
   
   -- Fin de les operacions
   rst := 'OK: S''ha donat d''alta el consum mitj d''un any';

   p_insertLog('p_altaEstValorMitja', 
               'cod_linia: ' || cod_linia || ',' ||
               'anyo: ' || anyo || ',' ||
      'valor_mitja: ' || valor_mitja, rst);
   COMMIT;
   
EXCEPTION


   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
  p_insertLog('p_altaEstValorMitja', 
               'cod_linia: ' || cod_linia || ',' ||
               'anyo: ' || anyo || ',' ||
      'valor_mitja: ' || valor_mitja, rst);
  ROLLBACK;
END p_altaEstValorMitja;
/

