CREATE OR REPLACE PROCEDURE         p_estConsumMig IS

    a_consum   NUMBER;
    a_mesos    NUMBER;
    a_mitja    NUMBER;


BEGIN  


  DECLARE CURSOR c_registros IS

  --Mostrem el NIF del client, el seu cod_contracte, fecha_inici i fecha_fic del contracte
  --i el condi del comptador
  
 SELECT CL.NIF, CT.COD_CONTRACTE, CT.COD_COMPTADOR, CT.DATA_ALTA, CT.DATA_FI
 FROM CONTRACTE CT, CLIENT CL
 WHERE CT.COD_CLIENT = CL.COD_CLIENT;
 
 v_reg c_registros%rowtype;
    
  BEGIN
  DELETE FROM EST_CONSUM_MIG;
   OPEN c_registros;
   LOOP
      FETCH c_registros INTO v_reg;
   exit when c_registros%NOTFOUND;
      

   a_consum := getConsByComptDates (v_reg.COD_COMPTADOR, v_reg.DATA_ALTA, v_reg.DATA_FI); 
   a_mesos := getMesos (v_reg.NIF, v_reg.COD_COMPTADOR, v_reg.DATA_FI);   
  
   
   --Dividim el consum total d'un comptador pels mesos que porta consumint
   --desde que es va donar d'alta el seu contracte fins a la seva data fi o
   --fins la data actual si el contracte encara est vigent.
   
   a_mitja := round ((a_consum/a_mesos),2);   
   
   
         INSERT INTO  EST_CONSUM_MIG (NIF, COD_COMPTADOR, CONSUM_MIG)
   VALUES (v_reg.NIF, v_reg.COD_COMPTADOR, a_mitja);
  
    END LOOP;
           
  CLOSE c_registros;   
 END; 





END p_estConsumMig;
/

