CREATE OR REPLACE PROCEDURE         p_modEstNomCentProduccio (
   n_anyo                        IN number
)
IS


err_msg                VARCHAR2 (100);
rst                  VARCHAR2(2000);
cenprod_superen        NUMBER;
central                NUMBER;


BEGIN



--Mirem el numero de centrals que generen menys del 30% de la produccio
--tenint en compte la seva capacitat_maxima (aquesta dada ve donada en valors anuals)
SELECT COUNT (*) into  cenprod_superen 
FROM   
(SELECT SUM(EM.ENERGIA_PROD), EM.COD_C_PRODUCCIO, CP.CAPACITAT_MAXIMA
FROM ENERGIA_ABSOLUTA EM, CENTRAL_PRODUCCIO CP
WHERE EM.COD_C_PRODUCCIO = CP.COD_C_PRODUCCIO AND
      EXTRACT (YEAR FROM EM.DATA_PROD) = 2011 AND
   EM.VALID = 'si'
GROUP BY EM.COD_C_PRODUCCIO, CP.CAPACITAT_MAXIMA
HAVING SUM(EM.ENERGIA_PROD) <= CP.CAPACITAT_MAXIMA * 0.3);


--Mirem el numero total de centrals que te la taula CENTRAL_PRODUCCIO      
   

SELECT COUNT (*) INTO central
FROM CENTRAL_PRODUCCIO;

 
   
   
   --Actualitzem el nou registre
   UPDATE EST_NOMBRE_CENTRAL_PRODUCCIO
   SET num_central_produccio =  cenprod_superen
   WHERE anyo = n_anyo;
   
     
   
   
   -- Fin de les operacions
   rst := 'OK: S''ha modificat els numeros de centrals';

   p_insertLog('p_modEstNomCentProduccio', 
               'anyo: ' || n_anyo ||
               'num_central_produccio: ' || cenprod_superen, rst);
   COMMIT;
   
EXCEPTION


   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
   p_insertLog('p_modEstNomCentProduccio', 
               'anyo: ' || n_anyo ||
               'num_central_produccio: ' || cenprod_superen, rst);
      ROLLBACK;
END p_modEstNomCentProduccio ;
/

