CREATE OR REPLACE PROCEDURE p_modEstPercentatgeLinies (
    n_anyo   IN number
 
    


)
IS


err_msg                VARCHAR2 (100);
rst                    VARCHAR2(2000);
linies_superen         NUMBER;
linies                 NUMBER;
n_percentatge_linies   NUMBER;

BEGIN

--Mirem el numero de linies que superen el 50% de l'energia consumida
--tenint en compte la seva capacitat_maxima (aquesta dada ve donada en valors anuals)
SELECT COUNT (*) INTO linies_superen 
FROM (  
      SELECT AC.COD_LINIA,  L.CAPACITAT_MAXIMA, SUM (LC.CONSUM_MES)
      FROM ALIMENTA_CENTRAL AC, LINIA L, CONNECTA_COMPTADOR CC, LECTURA_CONSUM LC
      WHERE AC.COD_LINIA = L.COD_LINIA AND
            AC.COD_C_DISTRIBUCIO = CC.COD_C_DISTRIBUCIO AND
            CC.COD_COMPTADOR = LC.COD_COMPTADOR AND LC.ESTAT = 'actiu' AND
            CC.ESTAT = 'actiu' AND AC.ESTAT = 'actiu' AND EXTRACT (YEAR FROM LC.DATA_LECTURA) = n_anyo
      GROUP BY AC.COD_LINIA, L.CAPACITAT_MAXIMA
      HAVING SUM (LC.CONSUM_MES) >= L.CAPACITAT_MAXIMA * 0.5);


--Mirem el numero total de linies que te la taula LINIES      
   
SELECT COUNT (*) INTO linies
FROM LINIA;

--Fem el caulcul del %

     n_percentatge_linies := ((LINIES_SUPEREN/LINIES) * 100);
 
   
   
   
   --Actualitzem el nou registre
   UPDATE EST_PERCENTATGE_LINIES
   SET percentatge_linies =  n_percentatge_linies
   WHERE anyo = n_anyo;
   
   
   
   
   
   -- Fin de les operacions
   rst := 'OK: S''ha modificat el percentatge';

   p_insertLog('p_modEstPercentatgeLinies', 
               'anyo: ' || n_anyo ||
               'percentatge_linies: ' || n_percentatge_linies, rst);
   COMMIT;
   
EXCEPTION

   
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rst :=    'ERROR:'
             || err_msg;
      
   p_insertLog('p_modEstPercentatgeLinies', 
               'anyo: ' || n_anyo ||
               'percentatge_linies: ' || n_percentatge_linies, rst);
      ROLLBACK;

END p_modEstPercentatgeLinies;
/

