
ALTER TABLE USR_ENE.CENTRAL_PRODUCCIO
 DROP PRIMARY KEY CASCADE;
DROP TABLE USR_ENE.CENTRAL_PRODUCCIO CASCADE CONSTRAINTS;

CREATE TABLE USR_ENE.CENTRAL_PRODUCCIO
(
  COD_C_PRODUCCIO   INTEGER                     NOT NULL,
  ENERGIA_MAXIMA    NUMBER                          NULL,
  DATA_INSPECCIO    DATE                        NOT NULL,
  CAPACITAT_MAXIMA  NUMBER                      NOT NULL,
  ADREA            VARCHAR2(100 BYTE)          NOT NULL,
  LOCALITAT         VARCHAR2(100 BYTE)          NOT NULL,
  CP                VARCHAR2(5 BYTE)                NULL,
  PAIS              VARCHAR2(50 BYTE)           NOT NULL,
  ESTAT             VARCHAR2(7 BYTE)            NOT NULL
)
TABLESPACE ENERGIA_DAT
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX USR_ENE.PK_COD_C_PRODUCCIO ON USR_ENE.CENTRAL_PRODUCCIO
(COD_C_PRODUCCIO)
LOGGING
TABLESPACE ENERGIA_IND
NOPARALLEL;


ALTER TABLE USR_ENE.CENTRAL_PRODUCCIO ADD (
  CONSTRAINT PK_COD_C_PRODUCCIO
 PRIMARY KEY
 (COD_C_PRODUCCIO)
    USING INDEX 
    TABLESPACE ENERGIA_IND);




ALTER TABLE USR_ENE.ALIMENTA_CENTRAL ADD (
  CONSTRAINT FK_COD_C_PRODUCCIO_ALIM_CENT 
 FOREIGN KEY (COD_C_PRODUCCIO) 
 REFERENCES USR_ENE.CENTRAL_PRODUCCIO (COD_C_PRODUCCIO));

ALTER TABLE USR_ENE.ENERGIA_ABSOLUTA ADD (
  CONSTRAINT FK_COD_C_PRODUCCIO_ENE_ABS 
 FOREIGN KEY (COD_C_PRODUCCIO) 
 REFERENCES USR_ENE.CENTRAL_PRODUCCIO (COD_C_PRODUCCIO));



