
ALTER TABLE USR_ENE.CLIENT
 DROP PRIMARY KEY CASCADE;
DROP TABLE USR_ENE.CLIENT CASCADE CONSTRAINTS;

CREATE TABLE USR_ENE.CLIENT
(
  COD_CLIENT  INTEGER                           NOT NULL,
  NIF         VARCHAR2(12 BYTE)                 NOT NULL,
  NOM         VARCHAR2(15 BYTE)                 NOT NULL,
  COGNOMS     VARCHAR2(50 BYTE)                 NOT NULL,
  ADREA      VARCHAR2(100 BYTE)                NOT NULL,
  LOCALITAT   VARCHAR2(100 BYTE)                NOT NULL,
  CP          VARCHAR2(5 BYTE)                  NOT NULL,
  PAIS        VARCHAR2(50 BYTE)                 NOT NULL,
  TELEFON     VARCHAR2(20 BYTE)                 NOT NULL,
  ESTAT       VARCHAR2(7 BYTE)                  NOT NULL
)
TABLESPACE ENERGIA_DAT
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX USR_ENE.PK_COD_CLIENT ON USR_ENE.CLIENT
(COD_CLIENT)
LOGGING
TABLESPACE ENERGIA_IND
NOPARALLEL;


CREATE UNIQUE INDEX USR_ENE.UK_CLIENT ON USR_ENE.CLIENT
(NIF)
LOGGING
TABLESPACE ENERGIA_IND
NOPARALLEL;


ALTER TABLE USR_ENE.CLIENT ADD (
  CONSTRAINT PK_COD_CLIENT
 PRIMARY KEY
 (COD_CLIENT)
    USING INDEX 
    TABLESPACE ENERGIA_IND);

ALTER TABLE USR_ENE.CLIENT ADD (
  CONSTRAINT UK_CLIENT
 UNIQUE (NIF)
    USING INDEX 
    TABLESPACE ENERGIA_IND);




ALTER TABLE USR_ENE.CONTRACTE ADD (
  CONSTRAINT FK_COD_CLIENT 
 FOREIGN KEY (COD_CLIENT) 
 REFERENCES USR_ENE.CLIENT (COD_CLIENT));



