
ALTER TABLE USR_ENE.COMPTADOR
 DROP PRIMARY KEY CASCADE;
DROP TABLE USR_ENE.COMPTADOR CASCADE CONSTRAINTS;

CREATE TABLE USR_ENE.COMPTADOR
(
  COD_COMPTADOR   INTEGER                       NOT NULL,
  COD_MODEL       INTEGER                       NOT NULL,
  REFERENCIA      VARCHAR2(20 BYTE)             NOT NULL,
  DATA_INSTAL     DATE                              NULL,
  CONSUM_ABSOLUT  NUMBER                            NULL,
  ADREA          VARCHAR2(100 BYTE)            NOT NULL,
  LOCALITAT       VARCHAR2(100 BYTE)            NOT NULL,
  CP              VARCHAR2(5 BYTE)              NOT NULL,
  PAIS            VARCHAR2(50 BYTE)             NOT NULL,
  ESTAT           VARCHAR2(10 BYTE)             NOT NULL
)
TABLESPACE ENERGIA_DAT
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX USR_ENE.PK_COD_COMPTADOR ON USR_ENE.COMPTADOR
(COD_COMPTADOR)
LOGGING
TABLESPACE ENERGIA_IND
NOPARALLEL;


CREATE UNIQUE INDEX USR_ENE.UK_REFERENCIA_COMPT ON USR_ENE.COMPTADOR
(REFERENCIA)
LOGGING
TABLESPACE ENERGIA_IND
NOPARALLEL;


ALTER TABLE USR_ENE.COMPTADOR ADD (
  CONSTRAINT PK_COD_COMPTADOR
 PRIMARY KEY
 (COD_COMPTADOR)
    USING INDEX 
    TABLESPACE ENERGIA_IND);

ALTER TABLE USR_ENE.COMPTADOR ADD (
  CONSTRAINT UK_REFERENCIA_COMPT
 UNIQUE (REFERENCIA)
    USING INDEX 
    TABLESPACE ENERGIA_IND);


ALTER TABLE USR_ENE.COMPTADOR ADD (
  CONSTRAINT FK_COD_MODEL 
 FOREIGN KEY (COD_MODEL) 
 REFERENCES USR_ENE.MODEL_COMPTADOR (COD_MODEL));




ALTER TABLE USR_ENE.CONTRACTE ADD (
  CONSTRAINT FK_COD_COMPTADOR 
 FOREIGN KEY (COD_COMPTADOR) 
 REFERENCES USR_ENE.COMPTADOR (COD_COMPTADOR));

ALTER TABLE USR_ENE.LECTURA_CONSUM ADD (
  CONSTRAINT FK_COD_COMPTADOR_LECTURA_COSUM 
 FOREIGN KEY (COD_COMPTADOR) 
 REFERENCES USR_ENE.COMPTADOR (COD_COMPTADOR));



