
ALTER TABLE USR_ENE.CONTRACTE
 DROP PRIMARY KEY CASCADE;
DROP TABLE USR_ENE.CONTRACTE CASCADE CONSTRAINTS;

CREATE TABLE USR_ENE.CONTRACTE
(
  COD_CONTRACTE  INTEGER                        NOT NULL,
  COD_COMPTADOR  INTEGER                        NOT NULL,
  COD_CLIENT     INTEGER                        NOT NULL,
  DATA_ALTA      DATE                           NOT NULL,
  DATA_FI        DATE                               NULL,
  POTENCIA       NUMBER                         NOT NULL,
  ESTAT          VARCHAR2(7 BYTE)               NOT NULL
)
TABLESPACE ENERGIA_DAT
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX USR_ENE.PK_COD_CONTRACTE ON USR_ENE.CONTRACTE
(COD_CONTRACTE)
LOGGING
TABLESPACE ENERGIA_IND
NOPARALLEL;


ALTER TABLE USR_ENE.CONTRACTE ADD (
  CONSTRAINT PK_COD_CONTRACTE
 PRIMARY KEY
 (COD_CONTRACTE)
    USING INDEX 
    TABLESPACE ENERGIA_IND);


ALTER TABLE USR_ENE.CONTRACTE ADD (
  CONSTRAINT FK_COD_COMPTADOR 
 FOREIGN KEY (COD_COMPTADOR) 
 REFERENCES USR_ENE.COMPTADOR (COD_COMPTADOR));

ALTER TABLE USR_ENE.CONTRACTE ADD (
  CONSTRAINT FK_COD_CLIENT 
 FOREIGN KEY (COD_CLIENT) 
 REFERENCES USR_ENE.CLIENT (COD_CLIENT));



