
ALTER TABLE USR_ENE.MODEL_COMPTADOR
 DROP PRIMARY KEY CASCADE;
DROP TABLE USR_ENE.MODEL_COMPTADOR CASCADE CONSTRAINTS;

CREATE TABLE USR_ENE.MODEL_COMPTADOR
(
  COD_MODEL    INTEGER                          NOT NULL,
  DATA_FAB     DATE                             NOT NULL,
  REFERENCIA   VARCHAR2(20 BYTE)                NOT NULL,
  EMPRESA_FAB  VARCHAR2(100 BYTE)               NOT NULL,
  DESCRIPCIO   VARCHAR2(100 BYTE)               NOT NULL,
  ADREA       VARCHAR2(100 BYTE)               NOT NULL,
  LOCALITAT    VARCHAR2(100 BYTE)               NOT NULL,
  CP           VARCHAR2(5 BYTE)                 NOT NULL,
  PAIS         VARCHAR2(50 BYTE)                NOT NULL,
  TELEFON      VARCHAR2(20 BYTE)                NOT NULL
)
TABLESPACE ENERGIA_DAT
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX USR_ENE.PK_COD_MODEL ON USR_ENE.MODEL_COMPTADOR
(COD_MODEL)
LOGGING
TABLESPACE ENERGIA_IND
NOPARALLEL;


CREATE UNIQUE INDEX USR_ENE.UK_REFERENCIA ON USR_ENE.MODEL_COMPTADOR
(REFERENCIA)
LOGGING
TABLESPACE ENERGIA_IND
NOPARALLEL;


ALTER TABLE USR_ENE.MODEL_COMPTADOR ADD (
  CONSTRAINT PK_COD_MODEL
 PRIMARY KEY
 (COD_MODEL)
    USING INDEX 
    TABLESPACE ENERGIA_IND);

ALTER TABLE USR_ENE.MODEL_COMPTADOR ADD (
  CONSTRAINT UK_REFERENCIA
 UNIQUE (REFERENCIA)
    USING INDEX 
    TABLESPACE ENERGIA_IND);




ALTER TABLE USR_ENE.COMPTADOR ADD (
  CONSTRAINT FK_COD_MODEL 
 FOREIGN KEY (COD_MODEL) 
 REFERENCES USR_ENE.MODEL_COMPTADOR (COD_MODEL));



